Index: kernel/zaptel-base.c
===================================================================
--- kernel/zaptel-base.c        (revision 4342)
+++ kernel/zaptel-base.c        (working copy)
@@ -2512,10 +2512,10 @@
 		spin_lock_irqsave(&chans[unit]->lock, flags);
 		chans[unit]->file = NULL;
 		spin_unlock_irqrestore(&chans[unit]->lock, flags);
+		clear_bit(ZT_FLAGBIT_OPEN, &chans[unit]->flags);
 		close_channel(chans[unit]);
 		if (chans[unit]->span && chans[unit]->span->close)
 			res = chans[unit]->span->close(chans[unit]);
-		clear_bit(ZT_FLAGBIT_OPEN, &chans[unit]->flags);
 	} else
 		res = -ENXIO;
 #ifndef LINUX26
